imgputt
=======

FreeBASIC image drawing library. Support H V flip, 90/180/270 degree rotation.

Original by counting_pine

[Put function that does simple transformations - freebasic.net](https://www.freebasic.net/forum/viewtopic.php?t=12074)

Fork. Added transparent color by mieki256

Screenshots
-----------

![ss_simple_sample.png](./screenshots/ss_simple_sample.png)

![ss_test_imgputt.png](./screenshots/ss_test_imgputt.png)

![ss_bench_imgputt.png](./screenshots/ss_bench_imgputt.png)

![ss_move_sample.png](./screenshots/ss_move_sample.png)

Environment
-----------

### Windows10 x64 22H2

* FreeBASIC 1.10.1 32bit
   * MinGW (gcc 6.3.0)
* FreeBASIC 1.10.1 64bit
   * MSYS2 (gcc 13.2.0)

### Ubuntu Linux 20.04 LTS (64bit)

* FreeBASIC 1.10.1 64bit
   * gcc 9.4.0

Build library
-------------

Please generate libimgputt.a.

```
fbc -lib imgputt.bas
```

If you have gcc, you should create the library with gcc. Libraries generated with gcc are twice as fast as gas.

```
fbc -lib imgputt.bas -gen gcc -O 2
```

Usage
-----

Place imgputt.bi and libimgputt.a in your project folder.

Below is a simple sample. The image will be displayed upside down.

```fb
#include once "imgputt.bi"

screenres 512, 288, 32
Dim As Any Ptr p = ImageCreate(288, 288)
Bload "obj_24bit.bmp", p

imgputt(p, , 10, 10, TRANSFORM_VFLIP, IMGPUT_TRANS, 96 * 2, 0, 96, 96)

imagedestroy p
sleep
```

paramater
---------

```
imgputt srcImg, dstImg, x, y, transform, DrawMode, sx, sy, sw, sh

srcImg    : Source image
dstImg    : Dest image
x, y      : Draw position x, y
transform : Transform mode or rotation angle (degree). Look imgputt.bi. 
DrawMode  : 0 (Trans) or 1 (Pset)
sx, sy, sw, sh : Source area x, y, width, height
```

About other sample
------------------

```
> test_imgputt.exe /?
Usage : test_imgputt.exe [BPP]
    BPP : 8, 16, 32

> bench_imgputt.exe /?
Usage : bench_imgputt.exe [BPP]
    BPP : 8, 16, 32
```

License
-------

Follow the imgput() license.

[Put function that does simple transformations - freebasic.net](https://www.freebasic.net/forum/viewtopic.php?t=12074)

