' imgputt() and PutEx() benchmark
'
' Usage : imgputt_test2.exe [BPP]
'     BPP : 8, 16, 32
'
' Last updated: <2024/02/08 08:20:35 +0900>

#include once "imgputt.bi"
#include "putex.bi"

Dim As Integer bpp = 32

' check command line option
Select Case Command(1)
Case "32" : bpp = 32
Case "16" : bpp = 16
Case "8"  : bpp = 8
Case "/?", "-h", "--help"
    Print "Usage : " & Command(0) & " [BPP]"
    Print "    BPP : 8, 16, 32" : end
End Select

screenres 512, 288, bpp

Dim As Any Ptr p = ImageCreate(288, 288)
Select Case bpp
Case 32 : Bload "obj_24bit.bmp", p
Case 16 : Bload "obj_16bit.bmp", p
Case 8  : Bload "obj_8bit.bmp",  p : color 14, 15 : cls
End Select

#define sx 0
#define sy (96 * 2)
#define sw 96
#define sh 96

Dim As Double starttime, t0, t1, t2
Dim As Integer max_count = 5000

Sub sub1(ByVal max_count As Integer, ByVal p As Any Ptr)
    For i As Integer = 0 To max_count
        Put (10, 10), p, (sx, sy) - Step(sw, sh), Trans
        ' Put (10, 10), p, (sx, sy) - Step(sw, sh), Pset
    Next i
End Sub

Sub sub2(ByVal max_count As Integer, ByVal p As Any Ptr)
    For i As Integer = 0 To max_count
        'imgputt( p, , 130, 10, TRANSFORM_HFLIP, IMGPUT_TRANS, sx, sy, sw, sh )
        imgputt( p, , 130, 10, TRANSFORM_VFLIP, IMGPUT_TRANS, sx, sy, sw, sh )
        'imgputt( p, , 130, 10, TRANSFORM_HFLIP Or TRANSFORM_VFLIP, IMGPUT_TRANS, sx, sy, sw, sh )
    Next i
End Sub

Sub sub3(ByVal max_count As Integer, ByVal p As Any Ptr)
    For i As Integer = 0 To max_count
        'PutEx(10, 130, p, sx, sy, sw, sh, 1)
        PutEx(10, 130, p, sx, sy, sw, sh, 2)
        'PutEx(10, 130, p, sx, sy, sw, sh, 3)
    Next i
End Sub

starttime = Timer
ScreenLock
sub1(max_count, p)
ScreenUnlock
t0 = Timer - starttime
sleep 100

starttime = Timer
ScreenLock
sub2(max_count, p)
ScreenUnlock
t1 = Timer - starttime
sleep 100

starttime = Timer
ScreenLock
sub3(max_count, p)
ScreenUnlock
t2 = Timer - starttime
sleep 100

Print "Put     : " & t0 & " sec (100%)"
Print "imgputt : " & t1 & " sec (" & int((t1 / t0) * 100) & "%)"
Print "PutEx   : " & t2 & " sec (" & int((t2 / t0) * 100) & "%)"

imagedestroy p
sleep
